// ComPortUI.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "ComPortUI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComPortUI dialog


CComPortUI::CComPortUI(CWnd* pParent /*=NULL*/)
	: CDialog(CComPortUI::IDD, pParent)
{
	//{{AFX_DATA_INIT(CComPortUI)
	//}}AFX_DATA_INIT
}


void CComPortUI::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComPortUI)
	DDX_Control(pDX, IDC_COMBO_STOPBIT, m_cComboStopbit);
	DDX_Control(pDX, IDC_COMBO_PARITY, m_cComboParity);
	DDX_Control(pDX, IDC_COMBO_DATABIT, m_cComboDatabit);
	DDX_Control(pDX, IDC_COMBO_COMPORT, m_cComboComPort);
	DDX_Control(pDX, IDC_COMBO_BAUDRATE, m_cComboBaudrate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CComPortUI, CDialog)
	//{{AFX_MSG_MAP(CComPortUI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComPortUI message handlers

BOOL CComPortUI::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if( m_strComPort.IsEmpty() )
	{
		m_cComboComPort.SetCurSel(0);
		m_cComboBaudrate.SetCurSel(2);
		m_cComboDatabit.SetCurSel(3);
		m_cComboStopbit.SetCurSel(0);
		m_cComboParity.SetCurSel(0);
	}
	else
	{
		m_cComboComPort.SetCurSel(m_iComPort-1);
		m_cComboBaudrate.SetCurSel(2);//m_iBaudrate
		m_cComboDatabit.SetCurSel(m_iDatabit-5);
		m_cComboStopbit.SetCurSel(m_iStopbit);
		m_cComboParity.SetCurSel(m_iParity);

	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CComPortUI::Init()
{
	m_iComPort = 1;
	m_strComPort = "COM1";
	m_iBaudrate = CBR_9600;
	m_iDatabit = 8;
	m_iStopbit = ONESTOPBIT;
	m_iParity = NOPARITY;
}


void CComPortUI::OnOK() 
{
	// TODO: Add extra validation here
	int iTemp;

	iTemp = m_cComboComPort.GetCurSel();
	if( iTemp < 0 )
	{
		iTemp = 0;
	}
	m_strComPort.Format("COM%d", iTemp+1);
	
	char chTemp[16];
	
	m_cComboDatabit.GetLBText(m_cComboDatabit.GetCurSel(), chTemp);
	m_iDatabit = atoi(chTemp);
	
	m_cComboBaudrate.GetLBText(m_cComboBaudrate.GetCurSel(), chTemp);
	m_iBaudrate = atoi(chTemp);

	iTemp = m_cComboStopbit.GetCurSel();
	if( iTemp < 0 )
	{
		iTemp = 0;
	}
	m_iStopbit = iTemp;
	
	iTemp = m_cComboParity.GetCurSel();
	if( iTemp < 0 )
	{
		iTemp = 0;
	}
	m_iParity = iTemp;

	CDialog::OnOK();
}
