#if !defined(AFX_UVCONTROL_H__616E2EA4_C63C_459C_8983_58BE70840B5A__INCLUDED_)
#define AFX_UVCONTROL_H__616E2EA4_C63C_459C_8983_58BE70840B5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UVControl.h : header file
//

#include "ComPortUI.h"
#include "gtComPort.h"

#define DEFAULT_UV_COMPORT 8

#define UV_CONTROL_FRONT	0
#define UV_CONTROL_COMPORT	1
//======== UV SOURCE ====================
#define UV_SOURCE_DEVICE_ID_LC8	0
#define UV_SOURCE_DEVICE_NAME_LC8	"LC8"

#define UV_SOURCE_DEVICE_ID_XCITE	1
#define UV_SOURCE_DEVICE_NAME_XCITE	"XCITE"

#define TIMER_EVENT_QUERY_UV_STATUS		1
#define TIMER_EVENT_INTENSITY_CONTROL	2
#define TIMER_EVENT_XCITE_READ_INTENSITY	3
#define TIMER_EVENT_XCITE_READ_SHUTTERTIME	4

#define TIMER_EVENT_LC8_SHUTTER_AUTO	5

//=========== XCite Query =================
#define QUERY_XCITE_NULL			0
#define QUERY_XCITE_SWVER			1
#define QUERY_XCITE_LAMP_HOUR		2
#define QUERY_XCITE_UNIT_STATUS		3
#define QUERY_XCITE_INTENSITY		4
#define QUERY_XCITE_EXPOSURE_TIME	5


/////////////////////////////////////////////////////////////////////////////
// CUVControl window
static void CALLBACK MMUVTimerProcess( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved 
#define DEFAULT_MMUVTIMER_RESOLUTION 5

class CUVControl : public CWnd
{
// Construction
public:
	CUVControl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUVControl)
	//}}AFX_VIRTUAL

// Implementation
public:
	void UVControl(CString strUVControl);
	void SetComPortInfo(CComPortUI *pComPortUI);
	CString m_strUVCommRecv;
	void ReceiveData(void);
	void SetMMTimer(int iEvent, int iTime);
	void ConnectXCite(void);
	int m_iXCiteStatusStep;
	void IntensityRead(void);
	int m_iQueryXCite;
	void ParseUVData_XCiteRecv(CString strRecv);
	void ManualShutterControl(BOOL bOpen);
	int m_iTimerEvent;
	UINT m_nTimerID;
	void ReadLampStatus(void);
	void LampControl(BOOL bOnOff);
	int m_iXCiteUVIntensityIndex;
	void IntensityControl(BOOL bUpDown);
	void ShutterTimeSet(void);
	void ShutterTimeRead(void);
	void ShutterManual(void);
	void ShutterAuto(void);
	void LampControl(void);
	void ControlMode(void);
	void SetDevice(int iDeviceID);
	void Init(CWnd *pWnd, CgtComPort *pComPort);
	void SetParentWnd(CWnd *pWnd);
	CWnd *m_pParentWnd;
	void ParseUVData_LC8Recv_CNT(CString strRecv);
	void ParseUVData_LC8Recv_INT(CString strRecv);
	void ParseUVData_LC8Recv_INP(CString strRecv);
	void ParseUVData_LC8Recv_AT0(CString strRecv);
	void CommSend(CString str);

	CgtComPort *m_pComPort;

	void SetComPortHandle(CgtComPort *pComPort);
	void ParseUVData(CString str);
	BOOL m_bIntensityMax;
	BOOL m_bIntensityMin;
	BOOL m_bManualOn;
	BOOL m_bLampOn;
	BOOL m_bControlMode;	//FALSE : Front, TRUE : COM Port
	CString m_strShutterTime;
	int m_iShutterTime;
	CString m_strIntensity;
	int m_iIntensity;
	CString m_strStatus;
	int m_iDeviceID;
	CString m_strDeviceName;

	virtual ~CUVControl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CUVControl)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UVCONTROL_H__616E2EA4_C63C_459C_8983_58BE70840B5A__INCLUDED_)
